import 'dart:io';
import 'package:printable_char/printable_char.dart';
import 'package:test/test.dart';

void main() {
  test('Basic chars', () {
    expect(isPrintable('a'.runes.first), isTrue);
    expect(isPrintable('💩'.runes.first), isTrue);
    expect(isPrintable('\n'.runes.first), isFalse);
  });

  test('All of the chars', () {
    var file = File.fromUri(Uri(path: 'test/is_print.txt')).openSync();

    final t = 't'.codeUnitAt(0);
    final f = 'f'.codeUnitAt(0);
    final newline = '\n'.codeUnitAt(0);

    int b;
    int rune;
    for (rune = 0; true; rune++) {
      bool goIsPrint;
      b = file.readByteSync();
      if (b == t) {
        goIsPrint = true;
      } else if (b == f) {
        goIsPrint = false;
      } else if (b == -1) {
        break;
      } else {
        throw 'Bad karma.';
      }

      expect(isPrintable(rune), equals(goIsPrint));

      b = file.readByteSync();
      if (b != newline) throw 'Bad karma.';
    }

    // You'll need to periodically increase this number whenever go updates
    // unicode support to a new unicode version.
    expect(rune, equals(1114112));

    file.closeSync();
  });
}
